package com.spring;

import java.lang.reflect.Method;

import org.springframework.aop.AfterReturningAdvice;
import org.springframework.aop.MethodBeforeAdvice;
import org.springframework.aop.ThrowsAdvice;

public class AudienceAdvice implements MethodBeforeAdvice,
		AfterReturningAdvice, ThrowsAdvice {

	public AudienceAdvice() {
	}

	@Override
	public void before(Method arg0, Object[] arg1, Object arg2)
			throws Throwable {

		audience.takeSeats();
		audience.turnOffCellPhones();
	}

	@Override
	public void afterReturning(Object arg0, Method arg1, Object[] arg2,
			Object arg3) throws Throwable {

		audience.applaud();
	}

	public void afterThrowing(Throwable throwable) {
		audience.demandRefund();
	}

	private Audience audience;

	public void setAudience(Audience audience) {
		this.audience = audience;
	}
}
