package com.spring;

import org.apache.log4j.Logger;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

public class SpringIdolMain {
	final static Logger logger = Logger.getLogger(SpringIdolMain.class);
	
	public static void main(String[] args) {
		ApplicationContext ctx = new ClassPathXmlApplicationContext("/com/spring/spring-idol.xml");
		logger.info("Spring context initialized.");
		Performer performer = (Performer) ctx.getBean("duke");
		performer.perform();
	}
}